public class AnimalExample1
{
    public static void main(String args[])
    {
        Animal[] circus = new Animal[4];
        circus[0] = new Bird();
        circus[1] = new Elephant();
        circus[2] = new Horse();
        circus[3] = new Bird();

        for (int k = 0; k < circus.length; k++)
                perform(circus[k]);
    }

    public static void perform(Animal a)
    {
        a.move();
        a.speak();
        a.speak();
        a.move();
    }
}

interface Animal
{
        public void move();
        public void speak();
}

class Bird implements Animal
{
        public void move() { System.out.println("fly"); }
        public void speak() { System.out.println("chirp"); }
}

class Horse implements Animal
{
        public void move() { System.out.println("trot"); }
        public void speak() { System.out.println("neigh"); }
}

class Elephant implements Animal
{
        public void move() { System.out.println("stomp"); }
        public void speak() { System.out.println("trumpet"); }
}
